Index: issm/trunk/src/c/Container/Loads.cpp
===================================================================
--- issm/trunk/src/c/Container/Loads.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Loads.cpp	(revision 13975)
@@ -46,5 +46,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		load=(Load*)(*object);
+		load=dynamic_cast<Load*>(*object);
 		load->Configure(elements,loads,nodes,vertices,materials,parameters);
 
@@ -53,9 +53,62 @@
 }
 /*}}}*/
-/*FUNCTION Loads::NumberOfLoads{{{*/
+/*FUNCTION Loads::IsPenalty{{{*/
+bool Loads::IsPenalty(int analysis_type){
+
+	int ispenalty=0;
+	int allispenalty=0;
+
+	/*Now go through all loads, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		if (load->InAnalysis(analysis_type)){
+			if(load->IsPenalty()) ispenalty++;
+		}
+	}
+
+	/*Grab sum of all cpus: */
+#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&ispenalty,(void*)&allispenalty,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	ispenalty=allispenalty;
+#endif
+
+	if(ispenalty)
+	 return true;
+	else
+	 return false;
+}
+/*}}}*/
+/*FUNCTION Loads::MaxNumNodes{{{*/
+int Loads::MaxNumNodes(int analysis_type){
+
+	int max=0;
+	int allmax;
+	int numnodes=0;
+
+	/*Now go through all loads, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		if (load->InAnalysis(analysis_type)){
+			numnodes=load->GetNumberOfNodes();
+			if(numnodes>max)max=numnodes;
+		}
+	}
+
+	/*Grab max of all cpus: */
+#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	max=allmax;
+#endif
+
+	return max;
+}
+/*}}}*/
+/*FUNCTION Loads::NumberOfLoads(){{{*/
 int Loads::NumberOfLoads(void){
 
-	int localloads=0;
-	int numberofloads=0;
+	int localloads;
+	int numberofloads;
 
 	/*Get number of local loads*/
@@ -64,12 +117,60 @@
 	/*figure out total number of loads combining all the cpus (no clones here)*/
 	#ifdef _HAVE_MPI_
-	MPI_Reduce(&localloads,&numberofloads,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&numberofloads,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Reduce(&localloads,&numberofloads,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&numberofloads,1,MPI_INT,0,IssmComm::GetComm());
 	#else
 	numberofloads=localloads;
 	#endif
 
+	return numberofloads;
+}
+/*}}}*/
+/*FUNCTION Loads::NumberOfLoads(int analysis){{{*/
+int Loads::NumberOfLoads(int analysis_type){
+
+	int localloads = 0;
+	int numberofloads;
+
+	/*Get number of local loads*/
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+
+		/*Check that this load corresponds to our analysis currently being carried out: */
+		if (load->InAnalysis(analysis_type)) localloads++;
+	}
+
+	/*figure out total number of loads combining all the cpus (no clones here)*/
+#ifdef _HAVE_MPI_
+	MPI_Reduce(&localloads,&numberofloads,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&numberofloads,1,MPI_INT,0,IssmComm::GetComm());
+#else
+	numberofloads=localloads;
+#endif
 
 	return numberofloads;
+}
+/*}}}*/
+/*FUNCTION Loads::Size(){{{*/
+int Loads::Size(void){
+
+	return this->DataSet::Size();
+}
+/*}}}*/
+/*FUNCTION Loads::Size(int analysis){{{*/
+int Loads::Size(int analysis_type){
+
+	int localloads = 0;
+
+	/*Get number of local loads*/
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+
+		/*Check that this load corresponds to our analysis currently being carried out: */
+		if (load->InAnalysis(analysis_type)) localloads++;
+	}
+
+	return localloads;
 }
 /*}}}*/
@@ -82,5 +183,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		load=(Load*)(*object);
+		load=dynamic_cast<Load*>(*object);
 		load->SetCurrentConfiguration(elements,loads,nodes,vertices,materials,parameters);
 
Index: issm/trunk/src/c/Container/Loads.h
===================================================================
--- issm/trunk/src/c/Container/Loads.h	(revision 13405)
+++ issm/trunk/src/c/Container/Loads.h	(revision 13975)
@@ -20,13 +20,17 @@
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Loads();
 		~Loads();
-		/*}}}*/
-		/*numerics: {{{*/
+
+		/*numerics*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		bool  IsPenalty(int analysis);
+		int   MaxNumNodes(int analysis);
 		int   NumberOfLoads(void);
+		int   NumberOfLoads(int analysis);
 		void  SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
-		/*}}}*/
+		int   Size(int analysis);
+		int   Size(void);
 
 };
Index: issm/trunk/src/c/Container/Materials.cpp
===================================================================
--- issm/trunk/src/c/Container/Materials.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Materials.cpp	(revision 13975)
@@ -46,5 +46,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		material=(Material*)(*object);
+		material=dynamic_cast<Material*>(*object);
 		material->Configure(elements);
 
Index: issm/trunk/src/c/Container/Materials.h
===================================================================
--- issm/trunk/src/c/Container/Materials.h	(revision 13405)
+++ issm/trunk/src/c/Container/Materials.h	(revision 13975)
@@ -19,11 +19,10 @@
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Materials();
 		~Materials();
-		/*}}}*/
-		/*numerics: {{{*/
+
+		/*numerics*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
-		/*}}}*/
 
 };
Index: issm/trunk/src/c/Container/Nodes.cpp
===================================================================
--- issm/trunk/src/c/Container/Nodes.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Nodes.cpp	(revision 13975)
@@ -46,5 +46,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		node=(Node*)(*object);
+		node=dynamic_cast<Node*>(*object);
 		node->Configure(nodes,vertices);
 
@@ -55,7 +55,4 @@
 /*FUNCTION Nodes::DistributeDofs{{{*/
 void  Nodes::DistributeDofs(int analysis_type,int setenum){
-
-	extern int num_procs;
-	extern int my_rank;
 
 	int  i;
@@ -67,4 +64,8 @@
 	int  numnodes=0;
 
+	/*recover my_rank:*/
+	int my_rank   = IssmComm::GetRank();
+	int num_procs = IssmComm::GetSize();
+
 	/*some check: */
 	_assert_(setenum==GsetEnum || setenum==FsetEnum || setenum==SsetEnum);
@@ -72,5 +73,5 @@
 	/*Go through objects, and distribute dofs locally, from 0 to numberofdofsperobject*/
 	for (i=0;i<this->Size();i++){
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -86,6 +87,6 @@
 	alldofcount=xNew<int>(num_procs);
 	#ifdef _HAVE_MPI_
-	MPI_Gather(&dofcount,1,MPI_INT,alldofcount,1,MPI_INT,0,MPI_COMM_WORLD);
-	MPI_Bcast(alldofcount,num_procs,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Gather(&dofcount,1,MPI_INT,alldofcount,1,MPI_INT,0,IssmComm::GetComm());
+	MPI_Bcast(alldofcount,num_procs,MPI_INT,0,IssmComm::GetComm());
 	#else
 	alldofcount[0]=dofcount;
@@ -94,12 +95,10 @@
 	/* Every cpu should start its own dof count at the end of the dofcount from cpu-1*/
 	dofcount=0;
-	if(my_rank!=0){
-		for(i=0;i<my_rank;i++){
-			dofcount+=alldofcount[i];
-		}
+	for(i=0;i<my_rank;i++){
+		dofcount+=alldofcount[i];
 	}
 	for (i=0;i<this->Size();i++){
 		/*Check that this node corresponds to our analysis currently being carried out: */
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->OffsetDofs(dofcount,setenum);
@@ -118,5 +117,5 @@
 
 	for (i=0;i<this->Size();i++){
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->ShowTrueDofs(truedofs,maxdofspernode,setenum);//give maxdofspernode, column size, so that nodes can index into truedofs
@@ -125,5 +124,5 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce((void*)truedofs,(void*)alltruedofs,numnodes*maxdofspernode,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
+	MPI_Allreduce((void*)truedofs,(void*)alltruedofs,numnodes*maxdofspernode,MPI_INT,MPI_MAX,IssmComm::GetComm());
 	#else
 	for(i=0;i<numnodes*maxdofspernode;i++)alltruedofs[i]=truedofs[i];
@@ -132,5 +131,5 @@
 	/* Now every cpu knows the true dofs of everyone else that is not a clone*/
 	for (i=0;i<this->Size();i++){
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 		if (node->InAnalysis(analysis_type)){
 			node->UpdateCloneDofs(alltruedofs,maxdofspernode,setenum);
@@ -148,9 +147,9 @@
 
 	int i;
-	extern int num_procs;
-
-	int* ranks=NULL;
-	int* minranks=NULL;
-	int  numnodes;
+	int num_procs;
+	int numnodes;
+
+	/*recover num_procs: */
+	num_procs=IssmComm::GetSize();
 
 	/*Figure out number of nodes for this analysis: */
@@ -158,7 +157,6 @@
 
 	/*Allocate ranks: */
-	ranks=xNew<int>(numnodes);
-	minranks=xNew<int>(numnodes);
-
+	int* ranks    = xNew<int>(numnodes);
+	int* minranks = xNew<int>(numnodes);
 	for(i=0;i<numnodes;i++)ranks[i]=num_procs; //no cpu can have rank num_procs. This is the maximum limit.
 
@@ -171,5 +169,5 @@
 	 * order of cpu rank. This is also why we initialized this array to num_procs.*/
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)ranks,(void*)minranks,numnodes,MPI_INT,MPI_MIN,MPI_COMM_WORLD);
+	MPI_Allreduce((void*)ranks,(void*)minranks,numnodes,MPI_INT,MPI_MIN,IssmComm::GetComm());
 	#else
 	for(i=0;i<numnodes;i++)minranks[i]=ranks[i];
@@ -179,5 +177,5 @@
 	for(i=0;i<this->Size();i++){
 
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -199,12 +197,12 @@
 
 	int i;
-	int   max=0;
-	int   allmax;
-	int   numdofs=0;
+	int max=0;
+	int allmax;
+	int numdofs=0;
 
 	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
 	for(i=0;i<this->Size();i++){
 
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -212,5 +210,5 @@
 
 			numdofs=node->GetNumberOfDofs(NoneApproximationEnum,setenum);
-			if (numdofs>max)max=numdofs;
+			if(numdofs>max)max=numdofs;
 		}
 	}
@@ -218,5 +216,5 @@
 	/*Grab max of all cpus: */
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
 	max=allmax;
 	#endif
@@ -228,13 +226,27 @@
 int   Nodes::NumberOfDofs(int analysis_type,int setenum){
 
-	int i;
-	
+	int   allnumdofs;
+
+	/*Get number of dofs on current cpu (excluding clones)*/
+	int numdofs=this->NumberOfDofsLocal(analysis_type,setenum);
+
+	/*Gather from all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce ( (void*)&numdofs,(void*)&allnumdofs,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	#else
+	allnumdofs=numdofs;
+	#endif
+	return allnumdofs;
+}
+/*}}}*/
+/*FUNCTION Nodes::NumberOfDofsLocal{{{*/
+int   Nodes::NumberOfDofsLocal(int analysis_type,int setenum){
+
 	int   numdofs=0;
-	int   allnumdofs;
 
 	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
-	for(i=0;i<this->Size();i++){
-
-		Node* node=(Node*)this->GetObjectByOffset(i);
+	for(int i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -243,18 +255,10 @@
 			/*Ok, this object is a node, ask it to plug values into partition: */
 			if (!node->IsClone()){
-
 				numdofs+=node->GetNumberOfDofs(NoneApproximationEnum,setenum);
-
 			}
 		}
 	}
 
-	/*Gather from all cpus: */
-	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)&numdofs,(void*)&allnumdofs,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-	#else
-	allnumdofs=numdofs;
-	#endif
-	return allnumdofs;
+	return numdofs;
 }
 /*}}}*/
@@ -264,12 +268,10 @@
 	/*Careful! only use once all clones have been setup for all nodes!: */
 
-	int i;
-	
-	int   numnodes=0;
-	int   allnumnodes=0;
+	int numnodes=0;
+	int allnumnodes=0;
 
 	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
-	for(i=0;i<this->Size();i++){
-		Node* node=(Node*)this->GetObjectByOffset(i);
+	for(int i=0;i<this->Size();i++){
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Ok, this object is a node, ask it to plug values into partition: */
@@ -279,5 +281,5 @@
 	/*Gather from all cpus: */
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)&numnodes,(void*)&allnumnodes,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
+	MPI_Allreduce ( (void*)&numnodes,(void*)&allnumnodes,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
 	#else
 	allnumnodes=numnodes;
@@ -298,5 +300,5 @@
 	for(i=0;i<this->Size();i++){
 
-		Node* node=(Node*)this->GetObjectByOffset(i);
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
 
 		/*Check that this node corresponds to our analysis currently being carried out: */
@@ -309,19 +311,14 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&max_sid,&node_max_sid,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD );
-	MPI_Bcast(&node_max_sid,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Reduce (&max_sid,&node_max_sid,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&node_max_sid,1,MPI_INT,0,IssmComm::GetComm());
 	max_sid=node_max_sid;
 	#endif
 
-	if(max_sid==1){
-		return 0;
-	}
-	else{
-		/*sid starts at 0*/
-		max_sid++;
-	
-		/*return*/
-		return max_sid;
-	}
+	/*sid starts at 0*/
+	max_sid++;
+
+	/*return*/
+	return max_sid;
 }
 /*}}}*/
@@ -329,25 +326,22 @@
 void   Nodes::Ranks(int* ranks,int analysis_type){
 
+	int my_rank;
+	int sid;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Go through nodes, and for each object, report it cpu: */
-
-	int i;
-	int rank;
-	int sid;
-	
-	for(i=0;i<this->Size();i++){
-
-		Node* node=(Node*)this->GetObjectByOffset(i);
-
-		/*Check that this node corresponds to our analysis currently being carried out: */
-		if (node->InAnalysis(analysis_type)){
-
-			rank=node->MyRank();
+	for(int i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+			/*Plug rank into ranks, according to sid: */
 			sid=node->Sid();
-
-			/*Plug rank into ranks, according to id: */
-			ranks[sid]=rank; 
-		}
-	}
-	return;
+			ranks[sid]=my_rank; 
+		}
+	}
 }
 /*}}}*/
@@ -358,11 +352,10 @@
 	Node* node=NULL;
 
-	for ( object=objects.begin() ; object < objects.end(); object++ ){
-
-		node=(Node*)(*object);
+	for (object=objects.begin() ; object < objects.end(); object++ ){
+
+		node=dynamic_cast<Node*>(*object);
 		node->SetCurrentConfiguration(nodes,vertices);
 
 	}
-
-}
-/*}}}*/
+}
+/*}}}*/
Index: issm/trunk/src/c/Container/Nodes.h
===================================================================
--- issm/trunk/src/c/Container/Nodes.h	(revision 13405)
+++ issm/trunk/src/c/Container/Nodes.h	(revision 13975)
@@ -13,9 +13,9 @@
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Nodes();
 		~Nodes();
-		/*}}}*/
-		/*numerics: {{{*/
+
+		/*numerics*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
 		void  DistributeDofs(int analysis_type,int SETENUM);
@@ -23,9 +23,9 @@
 		int   MaxNumDofs(int analysis_type,int setenum);
 		int   NumberOfDofs(int analysis_type,int setenum);
+		int   NumberOfDofsLocal(int analysis_type,int setenum);
 		int   NumberOfNodes(int analysis_type);
 		int   NumberOfNodes(void);
 		void  Ranks(int* ranks,int analysis_type);
 		void  SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
-		/*}}}*/
 
 };
Index: issm/trunk/src/c/Container/Observations.cpp
===================================================================
--- issm/trunk/src/c/Container/Observations.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Observations.cpp	(revision 13975)
@@ -40,5 +40,5 @@
 
 	/*Intermediaries*/
-	int          i,j,maxdepth,level,counter,index;
+	int          i,maxdepth,level,counter,index;
 	int          xi,yi;
 	IssmPDouble  xmin,xmax,ymin,ymax;
@@ -88,5 +88,5 @@
 		this->quadtree->ClosestObs(&index,x[i],y[i]);
 		if(index>=0){
-			observation=(Observation*)this->GetObjectByOffset(index);
+			observation=dynamic_cast<Observation*>(this->GetObjectByOffset(index));
 			if(pow(observation->x-x[i],2)+pow(observation->y-y[i],2) < minspacing) continue;
 		}
@@ -121,5 +121,4 @@
 
 	/*Output and Intermediaries*/
-	bool         stop;
 	int          nobs,i,index;
 	IssmPDouble  h2,hmin2,radius2;
@@ -136,5 +135,5 @@
 	this->quadtree->RangeSearch(&indices,&nobs,x_interp,y_interp,radius);
 	for (i=0;i<nobs;i++){
-		observation=(Observation*)this->GetObjectByOffset(indices[i]);
+		observation=dynamic_cast<Observation*>(this->GetObjectByOffset(indices[i]));
 		h2 = (observation->x-x_interp)*(observation->x-x_interp) + (observation->y-y_interp)*(observation->y-y_interp);
 
@@ -158,5 +157,5 @@
 	}
 	else{
-		observation=(Observation*)this->GetObjectByOffset(indices[index]);
+		observation=dynamic_cast<Observation*>(this->GetObjectByOffset(indices[index]));
 		*px=observation->x;
 		*py=observation->y;
@@ -195,5 +194,5 @@
 	nobs = 0;
 	for (i=0;i<tempnobs;i++){
-		observation=(Observation*)this->GetObjectByOffset(tempindices[i]);
+		observation=dynamic_cast<Observation*>(this->GetObjectByOffset(tempindices[i]));
 		h2 = (observation->x-x_interp)*(observation->x-x_interp) + (observation->y-y_interp)*(observation->y-y_interp);
 
@@ -237,5 +236,5 @@
 		/*Loop over all observations and fill in x, y and obs*/
 		for (i=0;i<nobs;i++){
-			observation=(Observation*)this->GetObjectByOffset(indices[i]);
+			observation=dynamic_cast<Observation*>(this->GetObjectByOffset(indices[i]));
 			observation->WriteXYObs(&x[i],&y[i],&obs[i]);
 		}
@@ -266,5 +265,5 @@
 		obs = xNew<IssmPDouble>(nobs);
 		for(int i=0;i<this->Size();i++){
-			observation=(Observation*)this->GetObjectByOffset(i);
+			observation=dynamic_cast<Observation*>(this->GetObjectByOffset(i));
 			observation->WriteXYObs(&x[i],&y[i],&obs[i]);
 		}
@@ -451,8 +450,8 @@
 
 	for(i=0;i<this->Size();i++){
-		observation1=(Observation*)this->GetObjectByOffset(i);
+		observation1=dynamic_cast<Observation*>(this->GetObjectByOffset(i));
 
 		for(j=i+1;j<this->Size();j++){
-			observation2=(Observation*)this->GetObjectByOffset(j);
+			observation2=dynamic_cast<Observation*>(this->GetObjectByOffset(j));
 
 			distance=sqrt(pow(observation1->x - observation2->x,2.) + pow(observation1->y - observation2->y,2.));
Index: issm/trunk/src/c/Container/Options.cpp
===================================================================
--- issm/trunk/src/c/Container/Options.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Options.cpp	(revision 13975)
@@ -42,5 +42,5 @@
 
 	char* name=NULL;
-	
+
 	vector<Object*>::iterator object;
 	Option* option=NULL;
@@ -60,5 +60,5 @@
 	for(object=objects.begin();object<objects.end();object++){
 
-		option=(Option*)(*object); 
+		option=dynamic_cast<Option*>(*object);
 		if (!strcmp(option->Name(),name)){
 			_error_("Options \"" << name << "\" found multiple times");
@@ -82,5 +82,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		option=(Option*)(*object); 
+		option=dynamic_cast<Option*>(*object);
 		if (!strncmp(name,option->Name(),strlen(option->Name()))){
 
Index: issm/trunk/src/c/Container/Options.h
===================================================================
--- issm/trunk/src/c/Container/Options.h	(revision 13405)
+++ issm/trunk/src/c/Container/Options.h	(revision 13975)
@@ -22,13 +22,9 @@
 		int  AddOption(Option* in_oobject);
 		Option* GetOption(const char* name);
-		
-		
+
 		template <class OptionType> void Get(OptionType* pvalue,const char* name){ /*{{{*/
 
-			vector<Object*>::iterator object;
-			GenericOption<OptionType>* genericoption=NULL;
-
 			/*Get option*/
-			genericoption=(GenericOption<OptionType>*)GetOption(name);
+			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -44,9 +40,6 @@
 		template <class OptionType> void Get(OptionType* pvalue,int* pnumel, const char* name){ /*{{{*/
 
-			vector<Object*>::iterator object;
-			GenericOption<OptionType>* genericoption=NULL;
-
 			/*Get option*/
-			genericoption=(GenericOption<OptionType>*)GetOption(name);
+			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -63,9 +56,6 @@
 		template <class OptionType> void Get(OptionType* pvalue,const char* name,OptionType default_value){ /*{{{*/
 
-			vector<Object*>::iterator object;
-			GenericOption<OptionType>* genericoption=NULL;
-
 			/*Get option*/
-			genericoption=(GenericOption<OptionType>*)GetOption(name);
+			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -80,9 +70,6 @@
 		template <class OptionType> void Get(OptionType* pvalue,int* pnumel, const char* name,OptionType default_value){ /*{{{*/
 
-			vector<Object*>::iterator object;
-			GenericOption<OptionType>* genericoption=NULL;
-
 			/*Get option*/
-			genericoption=(GenericOption<OptionType>*)GetOption(name);
+			GenericOption<OptionType>* genericoption=dynamic_cast<GenericOption<OptionType>*>(GetOption(name));
 
 			/*If the pointer is not NULL, the option has been found*/
@@ -103,9 +90,6 @@
 template <> inline void Options::Get(char** pvalue,const char* name,char* default_value){ /*{{{*/
 
-	vector<Object*>::iterator object;
-	GenericOption<char*>* genericoption=NULL;
-
 	/*Get option*/
-	genericoption=(GenericOption<char*>*)GetOption(name);
+	GenericOption<char*>* genericoption=dynamic_cast<GenericOption<char*>*>(GetOption(name));
 
 	/*If the pointer is not NULL, the option has been found*/
@@ -115,9 +99,6 @@
 	else{
 		/*Make a copy*/
-		char* outstring=NULL;
-		int   stringsize;
-
-		stringsize=strlen(default_value)+1;
-		outstring=xNew<char>(stringsize);
+		int   stringsize=strlen(default_value)+1;
+		char* outstring=xNew<char>(stringsize);
 		xMemCpy<char>(outstring,default_value,stringsize);
 		*pvalue=outstring;
